public class DynArrayIntList implements IntList {
  private static final int DEFAULT_CAPACITY = 10;

  int[] a;
  int size = 0;

  public DynArrayIntList() {
    a = new int[DEFAULT_CAPACITY];
  }

  public DynArrayIntList(int initialCapacity) {
    a = new int[initialCapacity];
  }

  public void add(int e) {
    add(size, e);
  }
  private void growArray() {
    int[] b = new int[a.length * 2];
    for (int i = 0; i < size; i++) {
      b[i] = a[i];
    }
    a = b;
  }
  public void add(int index, int e) {
    if (index < 0 || index > size) {
      throw new IndexOutOfBoundsException();
    }
    // Have we reached current capacity?
    if (size == a.length) growArray();
    // Shift all elements "after" index one step to the right to make space
    for (int i = size - 1; i >= index; i--) {
      a[i+1] = a[i];
    }
    // Insert new element.
    a[index] = e;
    size++;
  }
  public void remove(int index) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }

    size--; // Decrese size
    // Shift all elements in positions after element removed one step left.
    for (int i = index; i < size; i++) {
      a[i] = a[i+1];
    }
  }
  // Simply set size to 0. Next time, we overwrite old data.
  public void clear() {
    size = 0;
  }
  public int get(int index) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }
    // Just return data at index.
    return a[index];
  }
  public void set(int index, int e) {
    if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }
    // Just overwrite old data at index.
    a[index] = e;
  }
  public int size() {
    return size;
  }

}
